<script>
import { ref } from 'vue'
import axios from 'axios'
import { useUserStore } from "../store/user";
import Message from "./Message.vue";
import { NCard, NSpace, NSteps, NStep, NButton, NInput, NFormItem, NForm, NFormItemRow, NSelect, NSwitch, NUpload, NUploadDragger, NIcon, NP, NText, NDynamicInput, NCheckbox, NCheckboxGroup } from 'naive-ui';
import { ArchiveBoxIcon } from '@heroicons/vue/24/solid'
export default {
  data() {
    return {
      formValue: {"name": "", "locale": ""},
      options: [],
      data: {},
    }
  },
  components: {
    Message,
    ArchiveBoxIcon,
    NCard,
    NSpace,
    NSteps,
    NStep,
    NButton,
    NInput,
    NFormItem,
    NForm,
    NFormItemRow,
    NSelect,
    NUpload,
    NUploadDragger,
    NIcon,
    NP,
    NText,
    NDynamicInput,
    NCheckbox,
    NCheckboxGroup,
    NSwitch
  },
  methods: {
    async delete_course() {
        try {
        var response = await axios.delete("https://cognoro.xyz/course/delete?course=" + this.formValue.course);
        window.$message.success(
                'Course was deleted.'
              )
              this.fetchOptions();
      } catch {
        window.$message.error(
                'Please check the data and try again.'
              )
      }
    },
    async submit() {
      try {
        var response = await axios.post("https://cognoro.xyz/course/update", this.formValue);
        window.$message.success(
                'Course was edited.'
              )
              this.fetchOptions();
      } catch {
        window.$message.error(
                'Please check the data and try again.'
              )
      }
      },
      handleUpdateValue(value, option) {
        this.formValue.name = this.data[value].name;
        this.formValue.locale = this.data[value].locale;
    },
      async fetchOptions(){
      var response = await axios.get('https://cognoro.xyz/courses')
      this.options = [];
      response["data"]["data"].forEach(element => {
        var option = {
        label: element.name,
        value: element.id
      };
      this.options.push(option);
      this.data[element.id] = {name: element.name, locale: element.locale};
    });
      }
  },
  async prepare(data) {
    if (this.userStore.expiration * 1000 - Date.now() < 0) {
      await this.userStore.refresh();
    }
  },
  async setup() {
    const formRef = ref(null);
    const currentRef = ref(1);
    const userStore = useUserStore();
    if (userStore.expiration * 1000 - Date.now() < 0 || userStore.auth_token == null) {
      await userStore.refresh();
    }
    axios.defaults.headers.common['Authorization'] = userStore.auth_token;
    return {
      userStore, currentRef, formRef, currentStatus: ref("process"), headers: {Authentication: `Bearer ${userStore.auth_token}`}
    };
  },
};
</script>

<template>
  <Message/>
  <n-card class="sub">
    <n-space vertical>
      <n-steps :current="(currentRef)" :status="currentStatus">
        <n-step title="Course" description="" />
      </n-steps>
      <n-form ref="formRef" :model="formValue">
        <n-form-item-row label="Course" path="course">
          <n-select v-model:value="formValue.course" :options="options" @update:show="fetchOptions" @update:value="handleUpdateValue"/>
        </n-form-item-row>
        <n-form-item-row label="Name" path="name">
          <n-input v-model:value="formValue.name"/>
        </n-form-item-row>
        <n-form-item-row label="Locale" path="locale">
          <n-input v-model:value="formValue.locale" />
        </n-form-item-row>
      </n-form>
      <div>
        <n-button ghost color="#ff69b4" attr-type="submit" @click="submit">
          Edit
        </n-button>
        <n-button ghost color="#ff69b4" attr-type="submit" @click="delete_course">
          Delete
        </n-button>
      </div>
    </n-space>
  </n-card>
</template>